/*
AddAppInfo, Copyright (C) 1999-2000 Jean-Baptiste M. Queru

This program is free software; you can redistribute it and/or
modify it under the terms of the enclosed JBQ code license.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
License for more details.

Contact the author at:
Jean-Baptiste M. Queru, 31 Camino Alto, Millbrae CA 94030, USA
or by e-mail at : jb@queru.com
*/

#ifndef MACROS_H_
#define MACROS_H_

// exit with success
#define OKBYE {PostMessage(B_QUIT_REQUESTED);return;}

// exit with error
#define BYE {mainret=1;OKBYE;}

// report a parse error at the current word. the parameter explains the kind of error
#define PARSEERROR(x) {cutword(srcdata);fprintf(stderr,"%s:%d: "x" : %s\n",srcname,srcline,srcdata);BYE;}

// report a generic unlocated error. the parameter explains the kind of error
#define SOMEERROR(x) {fprintf(stderr,"%s: "x"\n",srcname);BYE;}

// report an error at the current line. the parameter explains the kind of error
#define LINEERROR(x) {fprintf(stderr,"%s:%d: "x"\n",srcname,srcline);BYE;}

// report an error. the paramaters are the kind of error and the offending parameter
#define NAMEERROR(x,n) {fprintf(stderr,"%s: "x" : %s\n",srcname,n);BYE;}

// report an error at the current line. the parameters are the kind of error and the offending parameter
#define LINENAMEERROR(x,n) {fprintf(stderr,"%s:%d: "x" : %s\n",srcname,srcline,n);BYE;}

// jump to the next word
#define NEXTWORD {srcdata=nextword(srcdata);}

// helper macro to create the dictionary used by the parser. used for named API constants
#define NAMEVAL(x) { #x ,x },

#endif
