/*
AddAppInfo, Copyright (C) 1999-2000 Jean-Baptiste M. Queru

This program is free software; you can redistribute it and/or
modify it under the terms of the enclosed JBQ code license.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
License for more details.

Contact the author at:
Jean-Baptiste M. Queru, 31 Camino Alto, Millbrae CA 94030, USA
or by e-mail at : jb@queru.com
*/

#ifndef PARSEHELPERS_H_
#define PARSEHELPERS_H_

#include <SupportDefs.h>

// structure used to store the keywords for the parser
struct keyval {
	const char*name;
	int32 value;
};

// return the beginning of the next word
char* nextword(char*t);

// insert a 0 at the end of the current word
void cutword(char*t);

// tests is pointer points to an end of line
bool endofline(char*t);

// tests is pointer points to an end of word (i.e. any char that doesn't belong to a word)
bool endofword(char*t);

// finds a value in a key/value array. returns true if found.
bool findvalue(char*t,keyval*vals,int32*val);

// finds a value in a key/value array, and or's it with the current value. returns true if found.
bool findorvalue(char*t,keyval*vals,int32*val);

// skip characters until something interesting happens. returns the number of lines that were skipped.
int skiplinecount(char**t);

// extracts an escaped word from the stream and advances the pointer accordingly
// WARNING : the word is created with strdup(), and must be freed with free()
char* extractword(char**t);

// extracts a number from the stream. return true if found.
bool extractnumber(char*t,uint32*n);

#endif
